



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>翻译:GLSL的顶点位移贴图</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">翻译:GLSL的顶点位移贴图</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 09:25:59 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>翻译:GLSL的顶点位移贴图</h1>
<p>翻译自: <a href="http://www.ozone3d.net/tutorials/vertex_displacement_mapping.php" rel="external nofollow noreferrer">Vertex Displacement Mapping using GLSL</a></p>
<ul><li>译者: FreeBlues</li></ul>
<blockquote><p>说明: 之所以选择这篇文档, 是因为现在但凡提到位移贴图(Displacement Mapping), 都要求设备支持镶嵌细分(tessellates), 但是目前大多数的移动设备都不支持这个特性, 而本文的年代比较久远(2006~2008), 那时的设备更不可能支持镶嵌细分了, 说明位移贴图并非必需镶嵌细分这个特性, 也意味着本文的实现方法可以在大多数设备上运行.</p></blockquote>
<h2>介绍</h2>
<p><code>顶点位移贴图</code>(<code>Vertex Displacement Mapping</code>)或者简单点儿<code>位移贴图</code>(<code>Displacement Mapping</code>) 是一种技术, 它允许用一个纹理贴图(<code>位移图-displacement map</code>)对一个多边形网格(mesh)进行变形, 以便增加表面细节. 它的原理并不新鲜. 它甚至是一些地形生成算法的基础(请参考 <a href="http://www.ozone3d.net/opengl_glut_tutorials.php#tut04" rel="external nofollow noreferrer">Terrain Generator</a> GLUT 项目). 新鲜的是使用 <code>GPU</code> 来实现实时网格变形.</p>
<ul><li>2006.11.5 更新</li></ul>
<p>位移贴图需要显卡允许在顶点着色器中访问至少一个纹理贴图单元. 在顶点着色器中访问纹理贴图被称为 <code>顶点纹理存取</code>(<code>Vertex Texture Fetching</code>). 着色器模型 <code>3.0</code> 强制实现在顶点着色器内至少有 <code>4</code> 个纹理单元能被访问. 现在, 只有基于 <code>nVidia</code> 的 <code>Geforce 6</code>, <code>Geforce 7</code> 以及更高版本支持 <code>顶点纹理存取</code>. <code>ATI</code> 显卡不支持 <code>顶点纹理存取</code>, 甚至连最新的高端型号比如 <code>X1950XTX</code> 也不支持(更多解释请看这里 <a href="http://www.ozone3d.net/blogs/lab/?p=71" rel="external nofollow noreferrer">ATI X1900XTX and VTF</a>)</p>
<ul><li>2006.11.22 更新</li></ul>
<p>看起来 <code>Forceware</code> 显卡驱动 <code>91.xx</code> 和 <code>91.xx</code> 有点问题. 老一点的驱动 (<code>84.xx</code>) 或者最新的 (<code>96.xx</code>) 都能正确地工作(这篇文章中有更多细节)</p>
<ul><li>2008.9.30 更新</li></ul>
<p><code>顶点纹理存取</code> 现在在 <code>radeon</code> 也可用了: <a href="http://www.geeks3d.com/?p=1525" rel="external nofollow noreferrer">ATI Catalyst 8.10 Fixes the Displacement Mapping Bug in OpenGL @ Geeks3D</a>.</p>
<p><a href="http://www.ozone3d.net/gpu_caps_viewer/" rel="external nofollow noreferrer"><code>GPU Caps Viewer</code></a> 工具允许你快速知道在顶点着色器中可访问纹理单元数:</p>
<p>截图:<br /><br />
<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/995377/201607/995377-20160723014048685-918032179.jpg"></p>
<p>这个信息能通过 <code>OpenGL</code> 的常量 <code>GL_MAX_VERTEX_TEXTURE_IMAGE_UNITS_ARB</code> 获得.</p>
<p>下面的截图展示了对本教程使用项目的渲染. 我们将会使用 <a href="http://www.ozone3d.net/demoniak3d/" rel="external nofollow noreferrer"><code>Demoniak3D</code></a> 平台以便快速编写位移贴图示例.</p>
<p>例程截图:<br /><br />
<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/995377/201607/995377-20160723013943529-1370070521.jpg"></p>
<p>不同的例程使用了 <code>GLSL</code> (<code>OpenGL Shading Language</code>) 进行着色器编程.</p>
<h2>位移原理</h2>
<p>用于变形的基本元素是从位移图中查询到的向量. 这个向量通常要么保存一个 <code>RGBA</code> 的颜色, 要么保存一个标量颜色(用灰度表示的高度图). 我们将会使用这个向量以及更精确的它的一些部件的总额, 作为一个因子, 用来改变顶点的位置. 最常见的一种方法是按前一个因子的比例沿着顶点的法线移动顶点的位置.</p>
<p>截图:<br /><br />
<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/995377/201607/995377-20160723014107029-1231008399.jpg"></p>
<p>上图可以总结为如下的关系:</p>
<pre class="prettyprint linenums"><code>P1 = P0 + (N * df * uf)<br />
</code></pre>
<ul><li><code>P0</code> 是顶点原始的位置</li>
<li><code>P1</code> 是位移之后的顶点位置</li>
<li><code>N</code> 是顶点的法线向量</li>
<li><code>df</code> 是被规范化的位移因子(如 <code>[0.0; 1.0]</code>)</li>
<li><code>uf</code> 是一个用户选择的缩放因子</li></ul>
<p><code>df</code> 能从下面的关系中获得, 它把一个 <code>RGB</code> 值转换成一个灰度值:</p>
<pre class="prettyprint linenums"><code>df = 0.30*dv.x + 0.59*dv.y + 0.11*dv.z<br />
</code></pre>
<p><code>dv</code> 就是当前被处理的顶点从位移图中获取的向量.</p>
<p>现在理论已经齐备, 只欠实践了...</p>
<h2>位移顶点着色器</h2>
<p>一旦所需的良好的工作条件准备妥当, 顶点着色器是相当简单的. 就像任何一种世界上的 <code>3D</code> 显卡的技术发展一样, <code>顶点位移贴图</code> 有一些少许的限制, 如果它们不在考虑在内，将会把你的 <code>Ultra-Boosted 7800 GTX</code> 变成一个古老的 <code>S3 trio</code> (你还记得......).</p>
<p>为了完成 <code>顶点位移贴图</code>, 这里有两个主要限制:</p>
<ul><li>位移图必须是浮点格式. 在 <code>OpenGL</code> 的条款中, 它意味着内部像素格式被设置为<code>GL_RGBA_FLOAT32_ATI</code> (<code>ATI</code> 和 <code>nVidia</code> 都能用).</li>
<li>位移图必须不能被过滤: 没有线性(linear)或三线性(trilinear)过滤, <code>Nearest</code> 模式是唯一被接受的.</li></ul>
<p>因此一旦位移图被以 <code>nearest</code> 模式过滤的浮点格式加载, 位移贴图实际上变得简单了, 如下面的顶点/像素着色器:</p>
<pre class="prettyprint linenums"><code>[Vertex_Shader]

uniform sampler2D displacementMap;

void main(void)<br />
{<br />
	vec4 newVertexPos;<br />
	vec4 dv;<br />
	float df;

	gl_TexCoord[0].xy = gl_MultiTexCoord0.xy;

	dv = texture2D( displacementMap, gl_MultiTexCoord0.xy );

	df = 0.30*dv.x + 0.59*dv.y + 0.11*dv.z;

	newVertexPos = vec4(gl_Normal * df * 100.0, 0.0) + gl_Vertex;

	gl_Position = gl_ModelViewProjectionMatrix * newVertexPos;<br />
}

[Pixel_Shader]

uniform sampler2D colorMap;

void main(void)<br />
{<br />
   gl_FragColor = texture2D(colorMap, gl_TexCoord[0].xy);<br />
}<br />
</code></pre>
<p>在顶点着色器中获取位移图跟我们在像素着色器中获取纹理贴图一样: 使用 <code>GLSL</code> 的 <code>texture2D()</code> 函数.</p>
<p><code>Demoniak3D</code> 的示例展示了一个 <code>80000</code> 个多边形网格用一个简单 <code>BMP</code> 图像的变形:</p>
<p>截图:<br /><br />
<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/995377/201607/995377-20160723014151982-499395257.jpg"></p>
<p><code>nearest</code> 过滤模式是今天硬件的顶点着色器里唯一可用的模式. 但是没有什么能够阻止我们实现我们自己的 <code>bilinear</code> 过滤模式. 这里是这个函数(改编自 <code>nVidia</code> 的 <code>Cg</code> 代码)做了这个工作:</p>
<pre class="prettyprint linenums"><code>#define textureSize 256.0<br />
#define texelSize 1.0 / 256.0

vec4 texture2D_bilinear( uniform sampler2D tex, vec2 uv )<br />
{<br />
	vec2 f = fract( uv.xy * textureSize );<br />
	vec4 t00 = texture2D( tex, uv );<br />
	vec4 t10 = texture2D( tex, uv + vec2( texelSize, 0.0 ));<br />
	vec4 tA = mix( t00, t10, f.x );<br />
	vec4 t01 = texture2D( tex, uv + vec2( 0.0, texelSize ) );<br />
	vec4 t11 = texture2D( tex, uv + vec2( texelSize, texelSize ) );<br />
	vec4 tB = mix( t01, t11, f.x );<br />
	return mix( tA, tB, f.y );<br />
}<br />
</code></pre>
<p>这个函数的使用很简单, 只要把 <code>texture2D()</code> 替换成 <code>texture2D_bilinear()</code> 就行了:</p>
<pre class="prettyprint linenums"><code>dv = texture2D_bilinear( displacementMap, gl_MultiTexCoord0.xy );<br />
</code></pre>
<p>这段代码在顶点着色器和像素着色器里都运行得很好.</p>
<h2>法线的问题</h2>
<p><code>顶点位移贴图</code> 最大的一个缺点是面对法线的顶点被破坏了因为对于未变形网格来说它们是有效的. 因为我们在一个顶点着色器中, 我们不能访问其他两个来自当前被处理的面的顶点, 然后我们无法重新计算法线.</p>
<p>不过有两种方式来解决这个棘手的问题: 第一个就是简单地不使用......法线! 使用静态光线(就像<code>光线贴图</code>-<code>lightmapping</code>), 法线就没用了, 因为光线来自<code>光线图</code>-<code>light-map</code>.</p>
<p>第二个方法是为像素着色器提供法线. 一个简单的方法是从位移图创建一个法线图. 法线图保存法线向量, 被指向模拟位移图的起伏. 这个技巧工作得非常好, 如果我们忘掉一些小缺点, 比如一些区域不应该被照亮.</p>
<p>下面这幅图展示了一个 <code>凹凸位移贴图</code>(<code>BumpDisplacementMapping</code>) 着色器的结果. 位移图和法线图都被根据基本图(石头的纹理贴图)创建了. 这个项目也可以在下载存档中可用.</p>
<p>截图:<br /><br />
<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/995377/201607/995377-20160723014231513-1673562397.jpg"></p>
<h2>结论</h2>
<p><code>顶点位移贴图</code> 能被用于创造很酷的效果并且允许发挥顶点处理器的威力, 它常常被遗忘于像素处理器的好处. 然而, 我们必须考虑到一些限制, 比如完成顶点纹理存取的硬件能力(<code>ATI/Radeon</code> 的 <code>GPU</code> 不支持 <code>顶点位移映射</code> ），法线的问题变成错误, 甚至不可能像 <code>shadow-volumes</code> 一样使用一些算法 （或者是你的 <code>3D</code> 引擎的一部分），因为这些算法处理的顶点存储在系统内存中, 而不是存储在 <code>GPU</code> 的图形内存中......</p>
<p>记着这些约束, <code>顶点位移贴图</code> 允许实现, 例如,极其逼真的水呈现模拟(见更多资源部分中的链接)或甚至互动顶点位移, 如下示例所示: 顶点位移是由一个 <code>AVI</code> 视频控制 （视频来源于 <a href="http://kmeleon.sourceforge.net/" rel="external nofollow noreferrer">K-Meleon</a> <code>web</code> 浏览器目录)</p>
<p>截图:<br /><br />
<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/995377/201607/995377-20160723014249669-1960600822.jpg"></p>
<h2>更多资源</h2>
<p><a href="http://developer.nvidia.com/object/using_vertex_textures.html" rel="external nofollow noreferrer">nVidia - Vertex Texture Fetch</a><br /><br />
<a href="http://www.gamasutra.com/features/20060103/kryachko_01.shtml" rel="external nofollow noreferrer">Using Vertex Texture Displacement for Realistic Water Rendering</a><br /><br />
<a href="http://www.lighthouse3d.com/opengl/glsl/index.php?ogloverview" rel="external nofollow noreferrer">OpenGL Setup for GLSL</a></p>
<h2>例程下载</h2>
<p>例程下载: <a href="http://www.ozone3d.net/downloads/tutorials/vertex_displacement_mapping.zip" rel="external nofollow noreferrer">例程</a></p>
<p>例程代码需要 <code>Demoniak3D</code> 才能正常运行.</p>
<p><code>Demoniak3D</code> 可以从这里下载: <a href="http://www.ozone3d.net/repository_hyperion_win32_installer.php" rel="external nofollow noreferrer">Demoniak3D Demo-System</a>.</p>
<h2>附录:教程提供的完整例程代码</h2>
<p>完整例程中给出了详细的参数设置和如何使用那些图像资源作为纹理, 只要稍微修改一下就可以在我们自己的 <code>OpenGL ES</code> 框架下直接使用.</p>
<h3>顶点位移贴图例程</h3>
<pre class="prettyprint linenums"><code>&lt;?xml version=&quot;1.0&quot; encoding=&quot;Windows-1252&quot; standalone=&quot;yes&quot;?&gt;<br />
&lt;!--<br />
==============================================================================<br />
AUTHOR:		JeGX - jegx@ozone3d.net<br />
DATE:		10.03.2006<br />
PURPOSE:	Vertex Displacement Mapping Demo.<br />
TUTORIAL:	http://www.ozone3d.net/tutorials/vertex_displacement_mapping.php

====================================<br />
 \==:: http://www.oZone3D.Net ::==/<br />
  ===============================<br />
==============================================================================<br />
--&gt;

&lt;hyperion version_major=&quot;1&quot; version_minor=&quot;2&quot; &gt;

&lt;!--<br />
The Scene!<br />
--&gt;<br />
&lt;scene name=&quot;displacement_mapping_demo&quot;<br />
       display_fps=&quot;TRUE&quot;<br />
       show_ref_grid=&quot;TRUE&quot;<br />
       vsync=&quot;TRUE&quot; &gt;

	&lt;infos_color r=&quot;1.0&quot; g=&quot;1.0&quot; b=&quot;1.0&quot; /&gt;<br />
	&lt;window_size width=&quot;1024&quot; height=&quot;768&quot; /&gt;<br />
	&lt;background_color r=&quot;0.3&quot; g=&quot;0.0&quot; b=&quot;0.0&quot; /&gt;<br />
	&lt;background_image image=&quot;data/stars.gif&quot; /&gt;

	&lt;!--<br />
	Check the GLSL support and the number of vertex shader texture units we need in this demo.<br />
	--&gt;<br />
	&lt;check_hardware_caps glsl=&quot;TRUE&quot; vs_tex_samplers=&quot;1&quot;<br />
	                     error_message=&quot;Sorry, this demo requires a Shader Model 3.0 (for vertex texture fetching) complient graphics controller. Demo startup failed. Bye...&quot; /&gt;

&lt;/scene&gt;

&lt;!--<br />
Setup an EXAMINE camera.<br />
--&gt;<br />
&lt;camera name=&quot;myCamera&quot; fov=&quot;60.0&quot; navigation_mode=&quot;EXAMINE&quot;  &gt;<br />
	&lt;position x=&quot;-143.41&quot; y=&quot;218.55&quot; z=&quot;241.49&quot; /&gt;<br />
	&lt;orientation pitch=&quot;30.0&quot; yaw=&quot;120.0&quot; /&gt;<br />
&lt;/camera&gt;

&lt;!--<br />
The base map (or color map)<br />
--&gt;<br />
&lt;texture name=&quot;colorMap&quot; filename=&quot;data/supernova.bmp&quot; pixel_format=&quot;RGB&quot; /&gt;

&lt;!--<br />
The displacement map.<br />
Note the RGBA_32F pixel format and the filtering mode (NONE==nearest).<br />
This is mandatory for vertex texture fetching on today's hardware.<br />
--&gt;<br />
&lt;texture name=&quot;displacementMap&quot;<br />
		 filename=&quot;data/supernova.bmp&quot;<br />
		 pixel_format=&quot;RGBA_32F&quot; filtering_mode=&quot;NONE&quot;<br />
		 num_mipmaps=&quot;0&quot; /&gt;

&lt;!--<br />
The mesh plane's material. We have to create it in order to attach the displacement shader.<br />
--&gt;<br />
&lt;material name=&quot;plane_mat&quot; shader_program_name=&quot;displacementShader&quot; /&gt;

&lt;!--<br />
The mesh plane: 200*200*2 = 80000 polys.<br />
In order to get decent frame rate, do not forget to set the VBO state...<br />
--&gt;<br />
&lt;mesh render=&quot;TRUE&quot; name=&quot;mesh_plane&quot; shape_type=&quot;PLANE&quot; texturing=&quot;TRUE&quot; lighting=&quot;FALSE&quot;<br />
      polygon_mode=&quot;SOLID&quot; use_vbo=&quot;TRUE&quot; back_face_culling=&quot;FALSE&quot; &gt;

	&lt;plane	x_size=&quot;400.0&quot; z_size=&quot;400.0&quot; num_segs_x=&quot;200&quot; num_segs_z=&quot;200&quot; /&gt;

	&lt;position x=&quot;0.0&quot; y=&quot;0.0&quot; z=&quot;0.0&quot; /&gt;<br />
	&lt;orientation pitch=&quot;0.0&quot;  /&gt;<br />
	&lt;attach_material name=&quot;plane_mat&quot; /&gt; 

	&lt;!--<br />
	The displacement map on texture unit 0.<br />
	--&gt;<br />
	&lt;texture texture_name=&quot;displacementMap&quot;<br />
	         material_name=&quot;plane_mat&quot;<br />
	         texture_unit=&quot;0&quot;<br />
	         u_tile=&quot;1.0&quot; v_tile=&quot;1.0&quot; /&gt;

	&lt;!--<br />
	The color map on texture unit 1.<br />
	--&gt;<br />
	&lt;texture texture_name=&quot;colorMap&quot;<br />
	         material_name=&quot;plane_mat&quot;<br />
	         texture_unit=&quot;1&quot;<br />
	         u_tile=&quot;1.0&quot; v_tile=&quot;1.0&quot; /&gt;<br />
&lt;/mesh&gt;

&lt;!--<br />
The displacement shader.<br />
--&gt;<br />
&lt;shader_program name=&quot;displacementShader&quot;  &gt;<br />
	&lt;constant_1i name=&quot;displacementMap&quot; value=&quot;0&quot; /&gt;<br />
	&lt;constant_1i name=&quot;colorMap&quot; value=&quot;1&quot; /&gt;

	&lt;raw_data&gt;&lt;![CDATA[<br />
	[Vertex_Shader]

	uniform float time;<br />
	uniform sampler2D displacementMap;

	#define textureSize 256.0<br />
	#define texelSize 1.0 / 256.0

	vec4 tex2D_bilinear( uniform sampler2D tex, vec2 t )<br />
	{<br />
		vec2 f = fract( t.xy * textureSize );<br />
		vec4 t00 = texture2D( tex, t );<br />
		vec4 t10 = texture2D( tex, t + vec2( texelSize, 0.0 ));<br />
		vec4 tA = mix( t00, t10, f.x );<br />
		vec4 t01 = texture2D( tex, t + vec2( 0.0, texelSize ) );<br />
		vec4 t11 = texture2D( tex, t + vec2( texelSize, texelSize ) );<br />
		vec4 tB = mix( t01, t11, f.x );<br />
		return mix( tA, tB, f.y );<br />
	}	

	void main(void)<br />
	{<br />
		vec4 newVertexPos;<br />
		vec4 dv;<br />
		float df;

		gl_TexCoord[0].xy = gl_MultiTexCoord0.xy;

		dv = tex2D_bilinear( displacementMap, gl_MultiTexCoord0.xy );<br />
		//dv = texture2D( displacementMap, gl_MultiTexCoord0.xy );

		df = 0.30*dv.x + 0.59*dv.y + 0.11*dv.z;

		newVertexPos = vec4(gl_Normal * df * 100.0, 0.0) + gl_Vertex;

		gl_Position = gl_ModelViewProjectionMatrix * newVertexPos;<br />
	}

	[Pixel_Shader]

	uniform sampler2D colorMap;

	void main(void)<br />
	{<br />
	   gl_FragColor = texture2D(colorMap, gl_TexCoord[0].xy);<br />
	}<br />
   	]]&gt;&lt;/raw_data&gt;

&lt;/shader_program&gt; 

&lt;!--<br />
A little bit of interactivity: swap the mesh plane polygon rendering mode.<br />
--&gt;<br />
&lt;script name=&quot;switch_polygon_mode&quot; run_mode=&quot;ASYNCHRONOUS&quot; &gt;<br />
	&lt;raw_data&gt;&lt;![CDATA[	 

	if( g_mode==NIL ) then<br />
		g_mode=0;<br />
	end

	WIREFRAME = 1;<br />
	SOLID = 2;

	if( g_mode==1 ) then<br />
		HYP_Object.SetPolygonMode( &quot;mesh_plane&quot;, SOLID );<br />
		g_mode=0;<br />
	else<br />
		HYP_Object.SetPolygonMode( &quot;mesh_plane&quot;, WIREFRAME );<br />
		g_mode=1;<br />
	end

   	]]&gt;&lt;/raw_data&gt;<br />
&lt;/script&gt; 

&lt;hotkey	name=&quot;space_key&quot; script=&quot;switch_polygon_mode&quot; key=&quot;KEY_SPACE&quot; /&gt;

&lt;!--<br />
The white rectangle under the supernova hud.<br />
--&gt;<br />
&lt;hud name=&quot;under_nova&quot; texturing=&quot;FALSE&quot; &gt;<br />
	&lt;size width=&quot;220&quot; height=&quot;220&quot; /&gt;<br />
	&lt;position x=&quot;380&quot; y=&quot;250&quot; /&gt;<br />
&lt;/hud&gt;

&lt;!--<br />
The hud that displays the small supernova image.<br />
--&gt;<br />
&lt;hud name=&quot;nova&quot; &gt;<br />
	&lt;texture texture_name=&quot;colorMap&quot; texture_unit=&quot;0&quot; /&gt;<br />
	&lt;size width=&quot;200&quot; height=&quot;200&quot; /&gt;<br />
	&lt;position x=&quot;380&quot; y=&quot;250&quot; /&gt;<br />
&lt;/hud&gt;

&lt;!--<br />
Display some information / commands<br />
--&gt;<br />
&lt;font name=&quot;myFontArial12&quot; render=&quot;TRUE&quot; ttf_name=&quot;Arial&quot; size=&quot;14&quot; &gt;<br />
	&lt;text_2d&gt;<br />
		&lt;color r=&quot;1.0&quot; g=&quot;1.0&quot; b=&quot;0.0&quot; /&gt;<br />
		&lt;position x=&quot;10&quot; y=&quot;30&quot; /&gt;<br />
		&lt;text text=&quot;Vertex Displacement Mapping Demo&quot; /&gt;<br />
	&lt;/text_2d&gt;

	&lt;text_2d&gt;<br />
		&lt;color r=&quot;1.0&quot; g=&quot;1.0&quot; b=&quot;0.0&quot; /&gt;<br />
		&lt;position x=&quot;10&quot; y=&quot;50&quot; /&gt;<br />
		&lt;text text=&quot;Controls:&quot; /&gt;<br />
	&lt;/text_2d&gt;

	&lt;text_2d&gt;<br />
		&lt;color r=&quot;1.0&quot; g=&quot;1.0&quot; b=&quot;0.0&quot; /&gt;<br />
		&lt;position x=&quot;20&quot; y=&quot;70&quot; /&gt;<br />
		&lt;text text=&quot;&gt; SPACE: switch polygon mode (WIREFRAME/SOLID)&quot; /&gt;<br />
	&lt;/text_2d&gt;<br />
&lt;/font&gt;

&lt;/hyperion&gt;<br />
</code></pre>
<h3>位移贴图+凹凸贴图</h3>
<pre class="prettyprint linenums"><code>&lt;?xml version=&quot;1.0&quot; encoding=&quot;Windows-1252&quot; standalone=&quot;yes&quot;?&gt;<br />
&lt;!--<br />
==============================================================================<br />
AUTHOR:		JeGX - jegx@ozone3d.net<br />
DATE:		10.03.2006<br />
PURPOSE:	Vertex Displacement Mapping Demo.<br />
TUTORIAL:	http://www.ozone3d.net/tutorials/vertex_displacement_mapping.php

====================================<br />
 \==:: http://www.oZone3D.Net ::==/<br />
  ===============================<br />
==============================================================================<br />
--&gt;

&lt;hyperion version_major=&quot;1&quot; version_minor=&quot;2&quot; &gt;

&lt;!--<br />
The Scene!<br />
--&gt;<br />
&lt;scene name=&quot;displacement_mapping_demo&quot;<br />
       display_fps=&quot;TRUE&quot;<br />
       show_ref_grid=&quot;TRUE&quot;<br />
       vsync=&quot;TRUE&quot; &gt;

	&lt;infos_color r=&quot;1.0&quot; g=&quot;1.0&quot; b=&quot;1.0&quot; /&gt;<br />
	&lt;window_size width=&quot;1024&quot; height=&quot;768&quot; /&gt;<br />
	&lt;background_color r=&quot;0.3&quot; g=&quot;0.0&quot; b=&quot;0.0&quot; /&gt;

	&lt;!--<br />
	Check the GLSL support and the number of vertex shader texture units we need in this demo.<br />
	--&gt;<br />
	&lt;check_hardware_caps glsl=&quot;TRUE&quot; vs_tex_samplers=&quot;1&quot;<br />
	                     error_message=&quot;Sorry, this demo requires a Shader Model 3.0 (for vertex texture fetching) complient graphics controller. Demo startup failed. Bye...&quot; /&gt;

&lt;/scene&gt;

&lt;!--<br />
Setup an EXAMINE camera.<br />
--&gt;<br />
&lt;camera name=&quot;myCamera&quot; fov=&quot;60.0&quot; navigation_mode=&quot;EXAMINE&quot;  &gt;<br />
	&lt;position x=&quot;-143.41&quot; y=&quot;218.55&quot; z=&quot;241.49&quot; /&gt;<br />
	&lt;orientation pitch=&quot;30.0&quot; yaw=&quot;120.0&quot; /&gt;<br />
&lt;/camera&gt;

&lt;light name=&quot;myLight&quot; render=&quot;TRUE&quot; type=&quot;OMNI&quot; &gt;<br />
	&lt;position x=&quot;10.0&quot; y=&quot;100.0&quot; z=&quot;45.0&quot; /&gt;<br />
	&lt;ambient r=&quot;0.4&quot; g=&quot;0.4&quot; b=&quot;0.4&quot; /&gt;<br />
	&lt;diffuse r=&quot;0.9&quot; g=&quot;0.9&quot; b=&quot;0.9&quot; /&gt;<br />
	&lt;specular r=&quot;0.9&quot; g=&quot;0.9&quot; b=&quot;0.9&quot; /&gt;<br />
&lt;/light&gt;

&lt;!--<br />
The base map (or color map)<br />
--&gt;<br />
&lt;texture name=&quot;colorMap&quot; filename=&quot;data/wall002_512x512.jpg&quot; /&gt;

&lt;!--<br />
The displacement map.<br />
Note the RGBA_32F pixel format and the filtering mode (NONE==nearest).<br />
This is mandatory for vertex texture fetching on today's hardware.<br />
--&gt;<br />
&lt;texture name=&quot;displacementMap&quot;<br />
		 filename=&quot;data/wall002_hmap2_512x512.jpg&quot;<br />
		 pixel_format=&quot;RGBA_32F&quot; filtering_mode=&quot;NONE&quot;<br />
		 num_mipmaps=&quot;0&quot; /&gt;

&lt;!--<br />
The normal map (or bump map)<br />
--&gt;<br />
&lt;texture name=&quot;normalMap&quot;<br />
		 filename=&quot;data/wall002_nmap2_512x512.jpg&quot;  /&gt;

&lt;!--<br />
The mesh plane's material. We have to create it in order to attach the displacement shader.<br />
--&gt;<br />
&lt;material name=&quot;plane_mat&quot; shader_program_name=&quot;displaceBumpMappingShader&quot; &gt;<br />
	&lt;ambient r=&quot;0.6&quot; g=&quot;0.6&quot; b=&quot;0.6&quot; /&gt;<br />
	&lt;diffuse r=&quot;0.9&quot; g=&quot;0.9&quot; b=&quot;0.9&quot; /&gt;<br />
	&lt;specular r=&quot;0.6&quot; g=&quot;0.6&quot; b=&quot;0.6&quot; /&gt;<br />
&lt;/material&gt;

&lt;!--<br />
The mesh plane: 200*200*2 = 80000 polys.<br />
In order to get decent frame rate, do not forget to set the VBO state...<br />
--&gt;<br />
&lt;mesh render=&quot;TRUE&quot; name=&quot;mesh_plane&quot; shape_type=&quot;PLANE&quot; texturing=&quot;TRUE&quot; lighting=&quot;FALSE&quot;<br />
      polygon_mode=&quot;SOLID&quot; use_vbo=&quot;TRUE&quot; back_face_culling=&quot;TRUE&quot; &gt;

	&lt;plane	x_size=&quot;400.0&quot; z_size=&quot;400.0&quot; num_segs_x=&quot;200&quot; num_segs_z=&quot;200&quot; /&gt;

	&lt;position x=&quot;0.0&quot; y=&quot;10.0&quot; z=&quot;0.0&quot; /&gt;<br />
	&lt;orientation pitch=&quot;0.0&quot;  /&gt;<br />
	&lt;attach_material name=&quot;plane_mat&quot; /&gt; 

	&lt;!--<br />
	The displacement map on texture unit 0.<br />
	--&gt;<br />
	&lt;texture texture_name=&quot;displacementMap&quot;<br />
	         material_name=&quot;plane_mat&quot;<br />
	         texture_unit=&quot;0&quot;<br />
	         u_tile=&quot;1.0&quot; v_tile=&quot;1.0&quot; /&gt;

	&lt;!--<br />
	The normal map on texture unit 1.<br />
	--&gt;<br />
	&lt;texture texture_name=&quot;normalMap&quot;<br />
	         material_name=&quot;plane_mat&quot;<br />
	         texture_unit=&quot;1&quot;<br />
	         u_tile=&quot;1.0&quot; v_tile=&quot;1.0&quot; /&gt;

	&lt;!--<br />
	The color map on texture unit 2.<br />
	--&gt;<br />
	&lt;texture texture_name=&quot;colorMap&quot;<br />
	         material_name=&quot;plane_mat&quot;<br />
	         texture_unit=&quot;2&quot;<br />
	         u_tile=&quot;1.0&quot; v_tile=&quot;1.0&quot; /&gt;<br />
&lt;/mesh&gt;

&lt;!--<br />
The displacement shader.<br />
--&gt;<br />
&lt;shader_program name=&quot;displaceBumpMappingShader&quot;  &gt;<br />
	&lt;constant_1i name=&quot;displacementMap&quot; value=&quot;0&quot; /&gt;<br />
	&lt;constant_1i name=&quot;normalMap&quot; value=&quot;1&quot; /&gt;<br />
	&lt;constant_1i name=&quot;colorMap&quot; value=&quot;2&quot; /&gt;<br />
	&lt;vertex_attrib name=&quot;tangent&quot; value=&quot;1&quot; /&gt;<br />
	&lt;constant_1f name=&quot;invRadius&quot; value=&quot;0.001&quot; /&gt;

	&lt;raw_data&gt;&lt;![CDATA[<br />
	[Vertex_Shader]

	varying vec3 lightVec;<br />
	varying vec3 eyeVec;<br />
	varying vec2 texCoord;<br />
	attribute vec3 tangent; 

	uniform sampler2D displacementMap;

	#define textureSize 1024.0<br />
	#define texelSize 1.0 / 1024.0

	vec4 tex2D_bilinear( uniform sampler2D tex, vec2 t )<br />
	{<br />
		vec2 f = fract( t.xy * textureSize );<br />
		vec4 t00 = texture2D( tex, t );<br />
		vec4 t10 = texture2D( tex, t + vec2( texelSize, 0.0 ));<br />
		vec4 tA = mix( t00, t10, f.x );<br />
		vec4 t01 = texture2D( tex, t + vec2( 0.0, texelSize ) );<br />
		vec4 t11 = texture2D( tex, t + vec2( texelSize, texelSize ) );<br />
		vec4 tB = mix( t01, t11, f.x );<br />
		return mix( tA, tB, f.y );<br />
	}	

	void main(void)<br />
	{<br />
		vec4 displacedVertexPos;<br />
		vec4 displacementVec;<br />
		float f;

		texCoord = gl_MultiTexCoord0.xy;

		displacementVec = tex2D_bilinear(displacementMap, gl_MultiTexCoord0.xy );<br />
		//f = (0.30*displacementVec.x + 0.59*displacementVec.y + 0.11*displacementVec.z);<br />
		f = displacementVec.x;

		displacedVertexPos = vec4(gl_Normal * f * 10.0, 0.0) + gl_Vertex;

		gl_Position = gl_ModelViewProjectionMatrix * displacedVertexPos;

		vec3 n = normalize(gl_NormalMatrix * gl_Normal);<br />
		vec3 t = normalize(gl_NormalMatrix * tangent);<br />
		vec3 b = cross(n, t);

	   	vec3 vVertex = vec3(gl_ModelViewMatrix * displacedVertexPos);<br />
		vec3 tmpVec = gl_LightSource[0].position.xyz - vVertex;

		lightVec.x = dot(tmpVec, t);<br />
		lightVec.y = dot(tmpVec, b);<br />
		lightVec.z = dot(tmpVec, n);

		tmpVec = -vVertex;<br />
		eyeVec.x = dot(tmpVec, t);<br />
		eyeVec.y = dot(tmpVec, b);<br />
		eyeVec.z = dot(tmpVec, n);<br />
	}

	[Pixel_Shader]

	varying vec3 lightVec;<br />
	varying vec3 eyeVec;<br />
	varying vec2 texCoord;<br />
	uniform sampler2D colorMap;<br />
	uniform sampler2D normalMap;<br />
	uniform float invRadius;

	void main (void)<br />
	{<br />
		float distSqr = dot(lightVec, lightVec);<br />
		float att = clamp(1.0 - invRadius * sqrt(distSqr), 0.0, 1.0);<br />
		vec3 lVec = lightVec * inversesqrt(distSqr);

		vec3 vVec = normalize(eyeVec);

		vec4 base = texture2D(colorMap, texCoord);<br />
		vec3 bump = normalize(texture2D(normalMap, texCoord).xyz * 2.0 - 1.0);

		vec4 vAmbient = gl_LightSource[0].ambient * gl_FrontMaterial.ambient;

		vec4 final_color = vAmbient*base;

		float diffuse = dot(lVec, bump);<br />
		if(diffuse&gt;0.0)<br />
		{<br />
			vec4 vDiffuse = gl_LightSource[0].diffuse * gl_FrontMaterial.diffuse * diffuse;	

			float specular = pow(clamp(dot(reflect(-lVec, bump), vVec), 0.0, 1.0), gl_FrontMaterial.shininess );<br />
			//float specular = 0.0;<br />
			vec4 vSpecular = gl_LightSource[0].specular * gl_FrontMaterial.specular *specular;	

			final_color += (vDiffuse*base + vSpecular) * att;<br />
		}

		gl_FragColor = final_color;<br />
	}<br />
   	]]&gt;&lt;/raw_data&gt;

&lt;/shader_program&gt; 

&lt;!--<br />
A little bit of interactivity: swap the mesh plane polygon rendering mode.<br />
--&gt;<br />
&lt;script name=&quot;switch_polygon_mode&quot; run_mode=&quot;ASYNCHRONOUS&quot; &gt;<br />
	&lt;raw_data&gt;&lt;![CDATA[	 

	if( g_mode==NIL ) then<br />
		g_mode=0;<br />
	end

	WIREFRAME = 1;<br />
	SOLID = 2;

	if( g_mode==1 ) then<br />
		HYP_Object.SetPolygonMode( &quot;mesh_plane&quot;, SOLID );<br />
		g_mode=0;<br />
	else<br />
		HYP_Object.SetPolygonMode( &quot;mesh_plane&quot;, WIREFRAME );<br />
		g_mode=1;<br />
	end

   	]]&gt;&lt;/raw_data&gt;<br />
&lt;/script&gt; 

&lt;hotkey	name=&quot;space_key&quot; script=&quot;switch_polygon_mode&quot; key=&quot;KEY_SPACE&quot; /&gt;

&lt;!--<br />
Display some information / commands<br />
--&gt;<br />
&lt;font name=&quot;myFontArial12&quot; render=&quot;TRUE&quot; ttf_name=&quot;Arial&quot; size=&quot;14&quot; &gt;<br />
	&lt;text_2d&gt;<br />
		&lt;color r=&quot;1.0&quot; g=&quot;1.0&quot; b=&quot;0.0&quot; /&gt;<br />
		&lt;position x=&quot;10&quot; y=&quot;30&quot; /&gt;<br />
		&lt;text text=&quot;Vertex Displacement Mapping Demo&quot; /&gt;<br />
	&lt;/text_2d&gt;

	&lt;text_2d&gt;<br />
		&lt;color r=&quot;1.0&quot; g=&quot;1.0&quot; b=&quot;0.0&quot; /&gt;<br />
		&lt;position x=&quot;10&quot; y=&quot;50&quot; /&gt;<br />
		&lt;text text=&quot;Controls:&quot; /&gt;<br />
	&lt;/text_2d&gt;

	&lt;text_2d&gt;<br />
		&lt;color r=&quot;1.0&quot; g=&quot;1.0&quot; b=&quot;0.0&quot; /&gt;<br />
		&lt;position x=&quot;20&quot; y=&quot;70&quot; /&gt;<br />
		&lt;text text=&quot;&gt; SPACE: switch polygon mode (WIREFRAME/SOLID)&quot; /&gt;<br />
	&lt;/text_2d&gt;<br />
&lt;/font&gt;

&lt;/hyperion&gt;<br />
</code></pre>
<h3>位移贴图视频</h3>
<ul><li>译者注: 这个功能可能只能在教程提供的 <code>3D</code> 演示平台上使用.</li></ul>
<pre class="prettyprint linenums"><code>&lt;?xml version=&quot;1.0&quot; encoding=&quot;Windows-1252&quot; standalone=&quot;yes&quot;?&gt;<br />
&lt;!--<br />
==============================================================================<br />
AUTHOR:		JeGX - jegx@ozone3d.net<br />
DATE:		10.03.2006<br />
PURPOSE:	Vertex Displacement Mapping Demo.<br />
TUTORIAL:	http://www.ozone3d.net/tutorials/vertex_displacement_mapping.php

====================================<br />
 \==:: http://www.oZone3D.Net ::==/<br />
  ===============================<br />
==============================================================================<br />
--&gt;

&lt;hyperion version_major=&quot;1&quot; version_minor=&quot;2&quot; &gt;

&lt;!--<br />
The Scene!<br />
--&gt;<br />
&lt;scene name=&quot;displacement_mapping_demo&quot;<br />
       display_fps=&quot;TRUE&quot;<br />
       show_ref_grid=&quot;TRUE&quot;<br />
       vsync=&quot;TRUE&quot; &gt;

	&lt;infos_color r=&quot;1.0&quot; g=&quot;1.0&quot; b=&quot;1.0&quot; /&gt;<br />
	&lt;window_size width=&quot;1024&quot; height=&quot;768&quot; /&gt;<br />
	&lt;background_color r=&quot;0.3&quot; g=&quot;0.0&quot; b=&quot;0.0&quot; /&gt;<br />
	&lt;background_image image=&quot;data/stars.gif&quot; /&gt;

	&lt;!--<br />
	Check the GLSL support and the number of vertex shader texture units we need in this demo.<br />
	--&gt;<br />
	&lt;check_hardware_caps glsl=&quot;TRUE&quot; vs_tex_samplers=&quot;1&quot;<br />
	                     error_message=&quot;Sorry, this demo requires a Shader Model 3.0 (for vertex texture fetching) complient graphics controller. Demo startup failed. Bye...&quot; /&gt;

&lt;/scene&gt;

&lt;!--<br />
Setup an EXAMINE camera.<br />
--&gt;<br />
&lt;camera name=&quot;myCamera&quot; fov=&quot;60.0&quot; navigation_mode=&quot;EXAMINE&quot;  &gt;<br />
	&lt;position x=&quot;-143.41&quot; y=&quot;218.55&quot; z=&quot;241.49&quot; /&gt;<br />
	&lt;orientation pitch=&quot;30.0&quot; yaw=&quot;120.0&quot; /&gt;<br />
&lt;/camera&gt;

&lt;!--<br />
The base map (or color map)<br />
--&gt;<br />
&lt;texture name=&quot;colorMap&quot; filename=&quot;data/throbber.avi&quot; pixel_format=&quot;RGB&quot; &gt;<br />
	&lt;size width=&quot;256&quot; height=&quot;256&quot; /&gt;<br />
&lt;/texture&gt;          

&lt;!--<br />
The displacement map.<br />
Note the RGBA_32F pixel format and the filtering mode (NONE==nearest).<br />
This is mandatory for vertex texture fetching on today's hardware.<br />
--&gt;<br />
&lt;texture name=&quot;displacementMap&quot; type=&quot;TEXTURE_2D&quot;<br />
		 filename=&quot;data/throbber.avi&quot;<br />
		 pixel_format=&quot;RGBA_32F&quot; filtering_mode=&quot;NONE&quot; addressing_mode=&quot;CLAMP&quot;<br />
		 num_mipmaps=&quot;0&quot; &gt;<br />
	&lt;size width=&quot;256&quot; height=&quot;256&quot; /&gt;<br />
&lt;/texture&gt;          

&lt;!--<br />
The mesh plane's material. We have to create it in order to attach the displacement shader.<br />
--&gt;<br />
&lt;material name=&quot;plane_mat&quot; shader_program_name=&quot;displacementShader&quot; /&gt;

&lt;!--<br />
The mesh plane: 100*100*2 = 20000 polys.<br />
In order to get decent frame rate, do not forget to set the VBO state...<br />
--&gt;<br />
&lt;mesh render=&quot;TRUE&quot; name=&quot;mesh_plane&quot; shape_type=&quot;PLANE&quot; texturing=&quot;TRUE&quot; lighting=&quot;FALSE&quot;<br />
      polygon_mode=&quot;SOLID&quot; use_vbo=&quot;TRUE&quot; back_face_culling=&quot;FALSE&quot; &gt;

	&lt;plane	x_size=&quot;400.0&quot; z_size=&quot;400.0&quot; num_segs_x=&quot;100&quot; num_segs_z=&quot;100&quot; /&gt;

	&lt;position x=&quot;0.0&quot; y=&quot;0.0&quot; z=&quot;0.0&quot; /&gt;<br />
	&lt;orientation pitch=&quot;0.0&quot;  /&gt;<br />
	&lt;attach_material name=&quot;plane_mat&quot; /&gt; 

	&lt;!--<br />
	The displacement map on texture unit 0.<br />
	--&gt;<br />
	&lt;texture texture_name=&quot;displacementMap&quot;<br />
	         material_name=&quot;plane_mat&quot;<br />
	         texture_unit=&quot;0&quot;<br />
	         u_tile=&quot;1.0&quot; v_tile=&quot;1.0&quot; /&gt;

	&lt;!--<br />
	The color map on texture unit 1.<br />
	--&gt;<br />
	&lt;texture texture_name=&quot;colorMap&quot;<br />
	         material_name=&quot;plane_mat&quot;<br />
	         texture_unit=&quot;1&quot;<br />
	         u_tile=&quot;1.0&quot; v_tile=&quot;1.0&quot; /&gt;<br />
&lt;/mesh&gt;

&lt;!--<br />
The displacement shader.<br />
--&gt;<br />
&lt;shader_program name=&quot;displacementShader&quot;  &gt;<br />
	&lt;constant_1i name=&quot;displacementMap&quot; value=&quot;0&quot; /&gt;<br />
	&lt;constant_1i name=&quot;colorMap&quot; value=&quot;1&quot; /&gt;<br />
	&lt;constant_1f name=&quot;time&quot; value=&quot;0.0&quot; /&gt;

	&lt;raw_data&gt;&lt;![CDATA[<br />
	[Vertex_Shader]

	uniform sampler2D displacementMap;

	#define textureSize 256.0<br />
	#define texelSize 1.0 / 256.0

	vec4 tex2D_bilinear( uniform sampler2D tex, vec2 t )<br />
	{<br />
		vec2 f = fract( t.xy * textureSize );<br />
		vec4 t00 = texture2D( tex, t );<br />
		vec4 t10 = texture2D( tex, t + vec2( texelSize, 0.0 ));<br />
		vec4 tA = mix( t00, t10, f.x );<br />
		vec4 t01 = texture2D( tex, t + vec2( 0.0, texelSize ) );<br />
		vec4 t11 = texture2D( tex, t + vec2( texelSize, texelSize ) );<br />
		vec4 tB = mix( t01, t11, f.x );<br />
		return mix( tA, tB, f.y );<br />
	}	

	void main(void)<br />
	{<br />
		vec4 displacedVertexPos;<br />
		vec4 displacementVec;<br />
		float f;

		gl_TexCoord[0].xy = gl_MultiTexCoord0.xy;

		//displacementVec = texture2D(displacementMap, gl_MultiTexCoord1.xy);<br />
		displacementVec = tex2D_bilinear(displacementMap, gl_MultiTexCoord1.xy);<br />
		f = (0.30*displacementVec.x + 0.59*displacementVec.y + 0.11*displacementVec.z);

		displacedVertexPos = vec4(gl_Normal * f * 100.0, 0.0) + gl_Vertex;

		gl_Position = gl_ModelViewProjectionMatrix * displacedVertexPos;<br />
	}

	[Pixel_Shader]

	uniform sampler2D colorMap;

	void main(void)<br />
	{<br />
	   gl_FragColor = texture2D(colorMap, gl_TexCoord[0].xy);<br />
	}<br />
   	]]&gt;&lt;/raw_data&gt;

&lt;/shader_program&gt; 

&lt;!--<br />
Update time uniform variable for the displacement shader.<br />
--&gt;<br />
&lt;script name=&quot;update_scene&quot; run_mode=&quot;EXECUTE_EACH_FRAME&quot; &gt;<br />
	&lt;raw_data&gt;&lt;![CDATA[	 

	elapsed_time = HYP_GetElapsedTime() * 0.001;<br />
	HYP_GPUShader.SetConstant_1f( &quot;displacementShader&quot;, &quot;time&quot;, elapsed_time );

   	]]&gt;&lt;/raw_data&gt;<br />
&lt;/script&gt; 

&lt;!--<br />
A little bit of interactivity: swap the mesh plane polygon rendering mode.<br />
--&gt;<br />
&lt;script name=&quot;switch_polygon_mode&quot; run_mode=&quot;ASYNCHRONOUS&quot; &gt;<br />
	&lt;raw_data&gt;&lt;![CDATA[	 

	if( g_mode==NIL ) then<br />
		g_mode=0;<br />
	end

	WIREFRAME = 1;<br />
	SOLID = 2;

	if( g_mode==1 ) then<br />
		HYP_Object.SetPolygonMode( &quot;mesh_plane&quot;, SOLID );<br />
		g_mode=0;<br />
	else<br />
		HYP_Object.SetPolygonMode( &quot;mesh_plane&quot;, WIREFRAME );<br />
		g_mode=1;<br />
	end

   	]]&gt;&lt;/raw_data&gt;<br />
&lt;/script&gt; 

&lt;hotkey	name=&quot;space_key&quot; script=&quot;switch_polygon_mode&quot; key=&quot;KEY_SPACE&quot; /&gt;

&lt;!--<br />
The white rectangle under the hud.<br />
--&gt;<br />
&lt;hud name=&quot;under_nova&quot; texturing=&quot;FALSE&quot; &gt;<br />
	&lt;size width=&quot;220&quot; height=&quot;220&quot; /&gt;<br />
	&lt;position x=&quot;380&quot; y=&quot;250&quot; /&gt;<br />
&lt;/hud&gt;

&lt;!--<br />
The hud that displays the small image.<br />
--&gt;<br />
&lt;hud name=&quot;nova&quot; &gt;<br />
	&lt;texture texture_name=&quot;colorMap&quot; texture_unit=&quot;0&quot; /&gt;<br />
	&lt;size width=&quot;200&quot; height=&quot;200&quot; /&gt;<br />
	&lt;position x=&quot;380&quot; y=&quot;250&quot; /&gt;<br />
&lt;/hud&gt;

&lt;!--<br />
Display some information / commands<br />
--&gt;<br />
&lt;font name=&quot;myFontArial12&quot; render=&quot;TRUE&quot; ttf_name=&quot;Arial&quot; size=&quot;14&quot; &gt;<br />
	&lt;text_2d&gt;<br />
		&lt;color r=&quot;1.0&quot; g=&quot;1.0&quot; b=&quot;0.0&quot; /&gt;<br />
		&lt;position x=&quot;10&quot; y=&quot;30&quot; /&gt;<br />
		&lt;text text=&quot;Vertex Displacement Mapping Demo&quot; /&gt;<br />
	&lt;/text_2d&gt;

	&lt;text_2d&gt;<br />
		&lt;color r=&quot;1.0&quot; g=&quot;1.0&quot; b=&quot;0.0&quot; /&gt;<br />
		&lt;position x=&quot;10&quot; y=&quot;50&quot; /&gt;<br />
		&lt;text text=&quot;Controls:&quot; /&gt;<br />
	&lt;/text_2d&gt;

	&lt;text_2d&gt;<br />
		&lt;color r=&quot;1.0&quot; g=&quot;1.0&quot; b=&quot;0.0&quot; /&gt;<br />
		&lt;position x=&quot;20&quot; y=&quot;70&quot; /&gt;<br />
		&lt;text text=&quot;&gt; SPACE: switch polygon mode (WIREFRAME/SOLID)&quot; /&gt;<br />
	&lt;/text_2d&gt;<br />
&lt;/font&gt;

&lt;/hyperion&gt;<br />
</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8zry53q.html">【转载】查看freebsd 服务器硬件信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8oy76pq.html">jquery 清空 iframe 的内容，，iframe自适应高度</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kr7j7q.html">TaggingJS &ndash; 可以灵活定制的 jQuery 标签系统插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mxxg69.html">在Docker中运行web应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z7yj19.html">JS移动客户端--触屏滑动事件  banner图效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j5jm48.html">android基础----&amp;gt&semi;JSON数据的解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j00dzlq.html">html 实体  &equals;&amp;gt&semi; htmlspecialchars</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd22vl8.html">Cassandra笔记--2&period; 安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zzzvk9.html">HP服务器更换主板前后的注意事项</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1dwdyq.html">AI 人工智能 探索 （一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z534g9.html">python进程、进程池（二）代码部分</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj67369.html">URL控制器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlle446q.html">20190219备份 java spring boot 学习链接（日／英）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwdv179.html">ubuntu下objective-c的编译和运行</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy3r019.html">httpClient实例--返回响应部分并且转换成对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw5yyk8.html">pandas基础运算</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25z5goq.html">你所要掌握的最简单基础的React渲染优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g60veq.html">&lbrack;ES&rsqb;ES查询指南</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zk153n8.html">BZOJ&period;4407&period;于神之怒加强版&lpar;莫比乌斯反演&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkyvlx8.html">HP ALM lis</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qve3l5o9.html">MAVEN ERROR maven-resources-plugin</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mjr3m28.html">elasticsearch文档-字段的mapping</a>
			</li>
						<li><a href="https://www.batexi.com/a/8emrngk9.html">Beta阶段&mdash;&mdash;第一篇 Scrum 冲刺博客</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4p3xveq.html">php框架的制作原理</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kor327q.html">Oracle 数据库备份启用压缩以及remap</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql1pz4e9.html">Cocos2d入门及第一次运行时遇到的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qx2z0pv8.html">org&period;hibernate&period;UnknownEntityTypeException&colon; Unable to locate persister&colon; com&period;hibernate2&period;pojo&period;News &Tab;at org&period;hibernate&period;internal&period;SessionFactoryImpl&period;locateEntityPersister&lpar;SessionFactoryImpl&period;java&colon;797&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdjx0kxq.html">Hadoop 2&period;6&period;0   HIVE 2&period;1&period;1配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1vdkw4q.html">spring接收json字符串的两种方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/8emx4lj9.html">Springboot返回html</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
